<template>
  <div class="container" style="margin-left: 0px !important;">
    <div class="columns">
      <div class="column is-two-thirds">
        <section class="section">
          <div class="container"  style="margin-left: 0px !important;">
            <b-field grouped group-multiline>
              <button class="button field is-danger" @click="selected = null"
                  :disabled="!selected">
                  <b-icon icon="times"></b-icon>
                  <span>Clear selected</span>
              </button>
              <b-select v-model="perPage">
                <option value="5">5 per page</option>
                <option value="10">10 per page</option>
                <option value="15">15 per page</option>
                <option value="20">20 per page</option>
                <option value="50">50 per page</option>
                <option value="100">100 per page</option>
                <option value="-1">All Data</option>
              </b-select>
            </b-field>
            <b-table
              :data="cases"
              :selected.sync="selected"
              :bordered="isBordered"
              :paginated="isPaginated"
              :per-page="perPage"
              :current-page.sync="currentPage"
              :pagination-simple="isPaginationSimple"
              :pagination-position="paginationPosition"
              :default-sort-direction="defaultSortDirection"
              :sort-icon="sortIcon"
              :sort-icon-size="sortIconSize"
              default-sort="total_cases"
              aria-next-label="Next page"
              aria-previous-label="Previous page"
              aria-page-label="Page"
              aria-current-label="Current page"
            >
              <template slot-scope="props">
                <b-table-column field="country" label="Country" width="150" :searchable="isSearchable" sortable >
                  {{ props.row.country }}
                </b-table-column>
                <b-table-column field="total_cases" label="Total Cases" width="45" :searchable="isSearchable" sortable numeric>
                  {{ props.row.total_cases }}
                </b-table-column>
                <b-table-column :class="getClassColor(props.row)" width="20" field="new_cases_today" label="Today Cases" :searchable="isSearchable" sortable numeric>
                  {{ getModifiedData(props.row.new_cases_today) }}
                </b-table-column>
                <b-table-column width="40" field="percent_change" label="% Change" :searchable="isSearchable" sortable numeric>
                  <span :class="getBadgeColor(props.row.percent_change)">{{ getModifiedPercentage(props.row.percent_change) }}</span>
                </b-table-column>
                <b-table-column width="40" field="prediction" label="Forecasted New Cases (next 24 hrs)" :searchable="isSearchable" sortable numeric>
                  {{ props.row.prediction }}
                </b-table-column>
              </template>
            </b-table>
          </div>
        </section>
      </div>
      <div class="column is-one-third" style="margin-top: 8%;">
        <!-- Chart comes here -->
        <line-chart :selectedData="selected"/>
      </div>
    </div>
  </div>
</template>

<script>
import LineChart from './LineChart';
import axios from "axios";
const BASE_URL = process.env.VUE_APP_BASE_URL || "https://covid.monitaur.ai";

export default {
  components: {
    LineChart
  },
  data() {
    return {
      cases: [],
      selected: null,
      isBordered: true,
      isSearchable: true,
      isPaginated: true,
      perPage: 15,
      isPaginationSimple: false,
      paginationPosition: "bottom",
      defaultSortDirection: "desc",
      sortIcon: "arrow-up",
      sortIconSize: "is-small",
      currentPage: 1,
    };
  },
  methods: {
    getModifiedData(num){
      if(num > 0){
        return `+${num}`
      }
      return num
    },
    getClassColor(row){
      // Only color not selected rows.
      if(row != this.selected){
        if(row.new_cases_today > 0){
          return "bg-warning";
        }
      }
    },
    getModifiedPercentage(num){
      if(num > 0){
        return `+ ${num}%`
      } else if(num < 0){
        return `${num}%`
      }
    },
    getBadgeColor(num){
      if(num > 0){
        return "badge badge-danger";
      }else if(num < 0){
        return "badge badge-success";
      }
    },
    getCases() {
      axios
        .get(`${BASE_URL}/api/coronavirus/countries/cases`)
        .then(response => {
          this.cases = response.data.summary;
          let index = 0;
          let max = 0;
          for(let i = 0; i < this.cases.length; i++){
            if(this.cases[i].total_cases > max){
              index = i;
              max = this.cases[i].total_cases
            }
          }
          this.selected = this.cases[index];
        });
    }
  },
  created() {
    this.getCases();
  }
};
</script>

<style>
.table tr.is-selected{
  background-color: #524f5c !important;
  color: white;
}
</style>
